<?php

/* (c) yoya@awm.jp */

require_once('BitStream.php');
require_once('FlashSWF/TagBlock.php');

class FlashSWF {
        private $_header;
        private $_movie_header;
	private $_block_list;
        function __construct() {
	        $this->_initialize();
		return ;
	}
        function _initialize() {
	        $this->_header = array();
		$this->_movie_header = array();
		$this->_block_list = array();
	}
	/* input */
        function loadfile($filename) {
	        $swfdata = file_get_contents($filename);
		if ($swfdata === FALSE) {
		  // throw Exception("Can't open file($filename)");
		        return FALSE;
		}
	        $this->load($swfdata);
	}
        function load($swfdata) {
	        $this->_initialize();
	        $bs = new BitStream($swfdata);
		$magic = $bs->getStrings(3);
		$version = $bs->getByte();
		$filelength = $bs->getBytesLE(4);
                $this->_header['magic'] = $magic;
                $this->_header['version'] = $version;
		$this->_header['filelength'] = $filelength;
		if ($magic == 'FWS') {
		        ;
		} elseif ($magic == 'CWS') {
		        $movie_and_body = gzuncompress($bs->getStrings(), $filelength);
			$bs = new BitStream($movie_and_body);
		} else {
		        return ;
		}
		$this->_movie_header = $this->get_movie_header($bs);
		while(true) {
		  $block = FlashSWF_TagBlock::Factory($bs);
		  $this->_block_list[] = $block;
		  if ($block->getTagId() == 0) {
		    break;
		  }
		}
	}
	function get_movie_header(&$bs) {
	        $movie_header = array();
		$movie_align = $bs->getBits(5);
		$movie_header['align'] = $movie_align;
		$movie_header['x_min'] = $bs->getBits($movie_align);
		$movie_header['x_max'] = $bs->getBits($movie_align);
		$movie_header['y_min'] = $bs->getBits($movie_align);
		$movie_header['y_max'] = $bs->getBits($movie_align);
		$bs->align();
		$movie_header['frame_rate_decimal'] = $bs->getByte();
		$movie_header['frame_rate_integer'] = $bs->getByte();
		$movie_header['frame_rate_count'] = $bs->getBytesLE(2);
		return $movie_header;
	}
	/* XXX */
        function getBlockList() {
	  return $this->_block_list;
	}
	/* for edit */
	function replaceJpegData($jpegid, $jpegdata) {
	        foreach ($this->_block_list as &$block) {
		  if (($block->getTagId() == 6) // DefineBitsJPEG
		      && ($block->getJpegId() == $jpegid)) {
		          $block->setJpegData($jpegdata);
	    }
	  }
	}
	/* output */
        function savefile($filename) {
	        $swfdata = $this->save();
		file_put_contents($filename, $swfdata);
	}
        function save() {
	        /* header */
	        $bs = new BitStream();
		$bs->putStrings($this->_header['magic']);
		$bs->putByte($this->_header['version']);
		//	  $bs->putBytesLE($this->_header['filelength'], 4);
		$header_without_length = $bs->getData();
		/* movie header and body */
		$bs = new BitStream();
		$movie_header = $this->_movie_header;
		$movie_align = $movie_header['align'];
		$bs->putBits($movie_align, 5);
		$bs->putBits($movie_header['x_min'], $movie_align);
		$bs->putBits($movie_header['x_max'], $movie_align);
		$bs->putBits($movie_header['y_min'], $movie_align);
		$bs->putBits($movie_header['y_max'], $movie_align);
		$bs->flush();
		$bs->putByte($movie_header['frame_rate_decimal']);
		$bs->putByte($movie_header['frame_rate_integer']);
		$bs->putBytesLE($movie_header['frame_rate_count'], 2);
		$movie_and_body = $bs->getData();
		foreach($this->_block_list as $block) {
	                $movie_and_body .=  $block->save();
		}
		$magic = $this->_header['magic'];
		$this->_header['filelength'] = strlen($header_without_length) + 4 + strlen($movie_and_body);
		if ($magic == 'CWS') {
	                $movie_and_body = gzcompress($movie_and_body, 6);
		} elseif ($magic == 'FWS') {
	          //
		} else {
	                fprintf("Unknown magic string %s\n", $magic);
			exit(1);
		}
		$bs = new BitStream();
		$bs->putBytesLE($this->_header['filelength'], 4);
		$length_field = $bs->getData();
		return $header_without_length  . $length_field . $movie_and_body;
	}
	function dump() {
                var_dump($this->_header);
                var_dump($this->_movie_header);
		foreach ($this->_block_list as $block) {
		        $block->dump();
		}
	}
}


