<?php

/* (c) yoya@awm.jp */

require_once('BitStream.php');

class FlashSWF_TagBlock {
        private static $_tagNameTable =
	  array(0 => 'End',
		1 => 'ShowFrame',
		2 => 'DefineShape',
		6 => 'DefineBitsJPEG',
		8 => 'JPEGTables',
		9 => 'SetBackgroundColor',
		12 =>'DoAction',
		22 => 'DefineShape2',
		26 =>'PlaceObject2',
		28 => 'RemoveObject2',
		34 => 'DefineButton2',
		35 => 'DefineBitsJPEG3',
		37 => 'DefineEditText', // Version 4.0
		39 => 'DefineSprite',
		43 => 'FrameLabel',
		48 => 'DefineFont2',
		);
        private static $_tagClassTable =
	  array(
		6 => 'DefineBitsJPEG',
		35 => 'DefineBitsJPEG3',
		);
	private $_tag;
	private $_length;
	private $_length_longformat;
	private $_rawdata;
	static function Factory(&$bs) {
	        $tag_and_length = $bs->getBytesLE(2);
		$tag = $tag_and_length >> 6;
		$length = $tag_and_length & 0x3f;
		if ($length == 0x3f) {
			$length = $bs->getBytesLE(4);
			$length_longformat = true;
		} else {
		        $length_longformat = false;
		}
		$rawdata = $bs->getStrings($length);
		$classname = __CLASS__;
		$tagclass = @ self::$_tagClassTable[$tag];
		if (! empty($tagclass)) {
		      require_once("FlashSWF/TagBlock/$tagclass.php");
		      $classname = $classname . '_' . $tagclass;
		}
		$block = new $classname($tag, $length, $length_longformat, $rawdata);
		return $block;
	}
	function __construct($tag, $length, $length_longformat, $rawdata) {
		$this->_tag = $tag;
		$this->_length = $length;
		$this->_length_longformat = $length_longformat;
		$this->_rawdata = $rawdata;
	}
	function getTagName() {
		$tag = $this->_tag;
		if (isset(self::$_tagNameTable[$tag])) {
		        return self::$_tagNameTable[$tag] . "($tag)";
		}
		return $tag;
	}
	function getTagId() {
	        return $this->_tag;
	}
	function getLength() {
	        return $this->_length;
	}
	function getData() { // must be override
	        return $this->_rawdata;
	}
	function save() {
	        $data = $this->getData();
		$length = strlen($data);
		$tag = $this->getTagId();
		$bs = new BitStream();
		if ((!$this->_length_longformat) && ($length < 0x3f)) {
	                $tag_and_length = ($tag << 6) | $length;
			$bs->putBytesLE($tag_and_length, 2);
		} else {
	                $tag_and_length = ($tag << 6) | 0x3f;
			$bs->putBytesLE($tag_and_length, 2);
			$bs->putBytesLE($length, 4);
		}
		return $bs->getData() . $this->getData();
	}
	function dump() {
	        $tagname = $this->getTagName();
		$length = $this->getLength();
		print "tag=$tagname length=$length\n";
	}
}
